| Qore DataProvider Module Reference 1.2.1

Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
DataProvider::NullDataProvider Class Reference

A dumrequest data provider that provides an empty hash as the request and response types. More...

Inheritance diagram for DataProvider::NullDataProvider:
[legend]

## Public Member Functions
| constructor (*hash< auto > options)
| Creates the object.
string | getName ()
| Returns the name of this data provider (`"NullRequest"`)
hash< DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
Public Member Functions inherited from DataProvider::AbstractDataProvider
| checkCreate ()
| Ensures that the data provider supports record creation. More...
| checkDelete ()
| Ensures that the data provider supports record deletion. More...
| checkRead ()
| Ensures that the data provider supports read operations. More...
| checkRequest ()
| Ensures that the data provider supports the request API. More...
| checkUpdate ()
| Ensures that the data provider supports record upserts. More...
| checkUpsert ()
| Ensures that the data provider supports record upserts. More...
| commit ()
| Commits data written to the data provider. More...
*hash< auto > | createRecord (hash< auto > rec, *hash< auto > create_options)
| Creates the given record in the data provider. More...
int | deleteRecords (*hash< auto > where_cond, *hash< auto > search_options)
| Deletes zero or more records. More...
auto | doRequest (auto req, *hash< auto > request_options)
| Makes a request and returns the response. More...
AbstractDataProviderBulkOperation | getBulkInserter ()
| Returns a bulk insert operation object for the data provider. More...
AbstractDataProviderBulkRecordInterface | getBulkRecordInterface (int block_size=1000, *hash< auto > search_options)
| Returns an iterator iterating all records with the bulk read API. More...
AbstractDataProviderBulkOperation | getBulkUpserter ()
| Returns a bulk upsert operation object for the data provider. More...
*AbstractDataProvider | getChildProvider (string name)
| Returns the given child provider or NOTHING if the given child is unknown. More...
AbstractDataProvider | getChildProviderEx (string name)
| Returns the given child provider or throws an exception if the given child is unknown. More...
*list< string > | getChildProviderNames ()
| Returns a list of child data provider names, if any. More...
AbstractDataProvider | getChildProviderPath (string path)
| Returns the given child provider from a `"/"` separated path string; throws an exception if any element in the path is unknown. More...
*hash< string, hash< DataProviderOptionInfo > > | getCreateOptions ()
| Returns options that can be used for creating records. More...
AbstractDataProviderType | getErrorResponseType (string error_code)
| Returns the type for the given error code. More...
*hash< string, AbstractDataProviderType > | getErrorResponseTypes ()
| Returns a hash of error responses, if any. More...
hash< DataProviderInfo > | getInfo ()
| Returns data provider info.
hash< auto > | getInfoAsData ()
| Returns static provider information as data; no objects are returned. More...
*hash< string, hash< MapperRuntimeKeyInfo > > | getMapperRuntimeKeys ()
| Returns custom data mapper runtime keys. More...
*hash< string, AbstractDataField > | getOrNothingRecordType (*hash< auto > search_options)
| Returns the description of the record type with "or nothing" types, if any.
AbstractDataProviderRecordIterator | getRecordIterator (*hash< auto > search_options)
| Returns an iterator iterating all records. More...
*hash< string, AbstractDataField > | getRecordType (*hash< auto > search_options)
| Returns the description of the record type, if any. More...
*hash< string, hash< DataProviderOptionInfo > > | getRequestOptions ()
| Returns options that can be used for requests. More...
*AbstractDataProviderType | getRequestType ()
| Returns the description of a successful request message, if any. More...
*AbstractDataProviderType | getResponseType ()
| Returns the description of a response message, if this object represents a response message. More...
*hash< string, hash< DataProviderOptionInfo > > | getSearchOptions ()
| Returns options that can be used for searching. More...
*hash< string, AbstractDataField > | getSoftRecordType (*hash< auto > search_options)
| Returns the description of the record type with soft types, if any.
*hash< string, hash< DataProviderOptionInfo > > | getUpsertOptions ()
| Returns options that can be used for upserting records. More...
bool | hasRecord ()
| Returns True if the data provider has a record type. More...
bool | recordRequiresSearchOptions ()
| Returns True if the data provider requires search options to retrieve the record type.
AbstractDataProviderRecordIterator | requestSearchRecords (auto req, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options according to an API request. More...
bool | requiresTransactionManagement ()
| Returns True if the data provider supports transaction management. More...
| rollback ()
| Rolls back data written to the data provider. More...
*hash< auto > | searchFirstRecord (hash< auto > where_cond, *hash< auto > search_options)
| Returns the first record matching the search options. More...
AbstractDataProviderRecordIterator | searchRecords (*hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
AbstractDataProviderBulkRecordInterface | searchRecordsBulk (int block_size=1000, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
*hash< auto > | searchSingleRecord (hash< auto > where_cond, *hash< auto > search_options)
| Returns a single record matching the search options. More...
bool | supportsBulkCreate ()
| Returns True if the data provider supports bulk creation output.
bool | supportsBulkRead ()
| Returns True if the data provider supports native bulk reading.
bool | supportsBulkUpsert ()
| Returns True if the data provider supports bulk upserts.
bool | supportsCreate ()
| Returns True if the data provider supports the record creation API.
bool | supportsDelete ()
| Returns True if the data provider supports the record deletion API.
bool | supportsNativeSearch ()
| Returns True if the data provider supports the record search API natively.
bool | supportsRead ()
| Returns True if the data provider supports reading.
bool | supportsRequest ()
| Returns True if the data provider supports requests.
bool | supportsUpdate ()
| Returns True if the data provider supports the record update API.
bool | supportsUpsert ()
| Returns True if the data provider supports the record upsert API.
int | updateRecords (hash< auto > set, *hash< auto > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options. More...
bool | updateSingleRecord (hash< auto > set, hash< auto > where_cond, *hash< auto > search_options)
| Updates a single record matching the search options. More...
string | upsertRecord (hash< auto > rec, *hash< auto > upsert_options)
| Upserts the given record in the data provider. More...

## Public Attributes
const | ProviderInfo = ...
| Provider info.

## Protected Member Functions
auto | doRequestImpl (auto req, *hash< auto > request_options)
| Returns an empty hash.
*hash< string, AbstractDataProviderType > | getErrorResponseTypesImpl ()
| Returns NOTHING.
*AbstractDataProviderType | getRequestTypeImpl ()
| Returns an empty hash type.
*AbstractDataProviderType | getResponseTypeImpl ()
| Returns an empty hash type.
Protected Member Functions inherited from DataProvider::AbstractDataProvider
*hash< auto > | checkOptions (string err, *hash< string, hash< DataProviderOptionInfo >> option_desc, *hash< auto > options)
| verifies options according to the option
*hash< auto > | createRecordImpl (hash< auto > rec, *hash< auto > create_options)
| Creates the given record to the data provider. More...
int | deleteRecordsImpl (*hash< auto > where_cond, *hash< auto > search_options)
| Deletes zero or more records. More...
auto | doRequestImpl (auto req, *hash< auto > request_options)
| Makes a request and returns the response. More...
| error (string err, string fmt)
| thrown an exception
*AbstractDataProvider | getChildProviderImpl (string name)
| Returns the given child provider or NOTHING if the given child is unknown. More...
*list< string > | getChildProviderNamesImpl ()
| Returns a list of child data provider names, if any. More...
AbstractDataProviderType | getErrorResponseTypeImpl (string error_code)
| Returns the type for the given error code. More...
*hash< string, AbstractDataProviderType > | getErrorResponseTypesImpl ()
| Returns a hash of error responses, if any. More...
*hash< string, AbstractDataField > | getRecordTypeImpl (*hash< auto > search_options)
| Returns the description of the record type, if any. More...
*AbstractDataProviderType | getRequestTypeImpl ()
| Returns the description of a successful request message, if any. More...
*AbstractDataProviderType | getResponseTypeImpl ()
| Returns the description of a response message, if this object represents a response message. More...
| processConstructorOptions (*hash< string, hash< DataProviderOptionInfo >> option_desc, *hash< auto > options)
| processes options passed to the constructor
*hash< auto > | processFieldValues (*hash< auto > h, *hash< auto > search_options)
| processes search or set values to convert types if necessary More...
AbstractDataProviderRecordIterator | requestSearchRecordsImpl (auto req, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options according to an API request. More...
*hash< auto > | searchFirstRecordImpl (hash< auto > where_cond, *hash< auto > search_options)
| Returns the first record matching the search options. More...
AbstractDataProviderBulkRecordInterface | searchRecordsBulkImpl (int block_size=1000, *hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
AbstractDataProviderRecordIterator | searchRecordsImpl (*hash< auto > where_cond, *hash< auto > search_options)
| Returns an iterator for zero or more records matching the search options. More...
*hash< auto > | searchSingleRecordImpl (hash< auto > where_cond, *hash< auto > search_options)
| Returns a single record matching the search options. More...
| throwUnimplementedException ()
| Throws an `INVALID-OPERATION` exception. More...
int | updateRecordsImpl (hash< auto > set, hash< auto > where_cond, *hash< auto > search_options)
| Updates zero or more records matching the search options. More...
bool | updateSingleRecordImpl (hash< auto > set, hash< auto > where_cond, *hash< auto > search_options)
| Updates a single record matching the search options. More...
string | upsertRecordImpl (hash< auto > rec, *hash< auto > upsert_options)
| Upserts the given record to the data provider. More...
*hash< auto > | validateCreateOptions (*hash< auto > create_options)
| validates create options More...
*hash< auto > | validateRequestOptions (*hash< auto > request_options)
| validates request options More...
*hash< auto > | validateSearchOptions (*hash< auto > search_options)
| validates search options More...
*hash< auto > | validateUpsertOptions (*hash< auto > upsert_options)
| validates upsert options More...

## Static Protected Member Functions
static HashDataType | type ()
| The default request and response type for this data provider.
Static Protected Member Functions inherited from DataProvider::AbstractDataProvider
static bool | checkCallbacks ()
| Checks if callbacks have already been set or locked.

## Additional Inherited Members
Static Public Member Functions inherited from DataProvider::AbstractDataProvider
static bool | setDynamicValueCallbacks ()
| Ensures that no callbacks can be set for dynamic URI resolution. More...
static bool | setDynamicValueCallbacks (code value_needs_resolution, code resolve_value)
| Set callbacks for dynamic URI resolution to allow for variable URI path elements to be resolved at runtime. More...
Static Protected Attributes inherited from DataProvider::AbstractDataProvider
static bool | callbacks_locked = False
| flag if callbacks are locked
static code | cb_resolve_value
| static callback for dynamic value resolution
static code | cb_value_needs_resolution
| static callback the returns a bool if the value needs dynamic resolution

## Detailed Description

A dumrequest data provider that provides an empty hash as the request and response types.